/***************************************************************************
                          CMyImage.h  -  description
                             -------------------
    begin                : Wed Jul 18 2001
    copyright            : (C) 2001 by Alper Yilmaz
    email                : yilmaz@cs.ucf.edu
 ***************************************************************************/
#ifndef __CMYIMAGE
#define __CMYIMAGE
#include "highgui.h"
#include "cv.h"
#include "cvaux.h"
#define WANT_STREAM                  // include.h will get stream fns
#define WANT_MATH                    // include.h will get math fns
#include "newmatap.h"                // need matrix applications
#include "newmatio.h"                // need matrix output routines
#ifdef use_namespace
using namespace NEWMAT;              // access NEWMAT namespace
#endif

enum IM_TYPE {PGM,PPM};

class CMyImage
{
	public:
		Matrix R;
		Matrix G;
		Matrix B;
		
		IM_TYPE type;

	public:
		int convert(IplImage* input);
		CMyImage();
		~CMyImage();
		
		int		Nrows		( ) {return R.Nrows();}
		int		Ncols		( ) {return R.Ncols();}

		void	read_file	(char *filename);
		void 	write_file	(char *filename);

    	void	draw_circle	(int ,int ,int ,float ,float, float);
        void	draw_cross	(int ,int ,int ,float ,float, float);
        void	draw_line	(int ,int ,int ,int ,float ,float, float);

        void	sub_sample 	(Matrix&,Matrix&,Matrix&);
};

#endif
