/***************************************************************************
                          definitions.h  -  description
                             -------------------
    begin                : Sat Aug 4 2001
    copyright            : (C) 2001 by Alper Yilmaz
    email                : yilmaz@cs.ucf.edu
 ***************************************************************************/

#ifndef __DEFINITIONS
#define __DEFINITIONS

	//--------------------------------------------------------
	#define MAX_NUMBER_OF_TARGETS 	1
	//--------------------------------------------------------
	#define TRACKING_PYRAMID_LEVELS	3
	//--------------------------------------------------------
	#define TRACKING_DEBUG
	//#undef	TRACKING_DEBUG
	//--------------------------------------------------------
	#define UPDATE_MODEL_ACCORDING_TO_DISTANCE
	#undef 	UPDATE_MODEL_ACCORDING_TO_DISTANCE
	//--------------------------------------------------------
	#define M_PI 3.14159

enum KERNEL_TYPE 	{MODEL, CANDIDATE};

struct PIXEL
{
	float x;
	float y;
};

struct KERNEL
{
	float		radius;
    float 		radius_sqr;  //this just for getting rid of square computation for making program faster
    float 		area;
    KERNEL_TYPE type;
    PIXEL		center;
};

struct SEQUENCE
{
	char	input_dir [200];
	char	output_dir[200];
	char	frame_name[100];
	char	image_type[5];
	int		start;
	int		end;
	int		bins;
};

#ifdef CALCULATE_DISTANCE_FROM_GROUND_TRUTH
struct GROUND_TRUTH
{
	PIXEL	center; 	//of the target
	float	x_diameter;	//of the target
	float	y_diameter;	//of the target
	float	x_x;		//square of x diameter
	float	y_y;		//square of y diameter
};
#endif		

#endif
