/***************************************************************************
                          utilities.h  -  description
                             -------------------
    begin                : Sun Jul 29 2001
    copyright            : (C) 2001 by Alper Yilmaz
    email                : yilmaz@cs.ucf.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define WANT_MATH                    // include.h will get math fns
#include "newmatap.h"                // need matrix applications
#ifdef use_namespace
using namespace NEWMAT;              // access NEWMAT namespace
#endif

enum FILTER_TYPE {STDV,R1,GAUSS,ALPER,GABOR};

ReturnMatrix 	filter	(FILTER_TYPE type,int radius=3,float sigma=.5,
					 int orientation=0,float scale=.5); //Special filters
ReturnMatrix 	conv 	(Matrix a,Matrix b); //convolution of 2 matrixes
ReturnMatrix 	pinv 	(Matrix A);
ReturnMatrix	abs		(Matrix A);
ReturnMatrix	hist	(Matrix A);
void		 	write_as_image(char*filename,Matrix a,bool normalize=true);
